NXOpen .NET Reference  12.0.0
Classes | Public Types | Public Member Functions | Properties | List of all members
NXOpen.Sketch Class Reference

Represents a sketch More...

Inheritance diagram for NXOpen.Sketch:
NXOpen.DisplayableObject NXOpen.IProfile NXOpen.NXObject NXOpen.IFitTo NXOpen.INXObject NXOpen.INXObject NXOpen.INXObject

Classes

struct  _ConstraintGeometry
 Used by the create geometric constraint methods to indicate what geometry the constraint should be applied to.
 
struct  _CopyObjectData
 This structure represents a map between the original object to be copied and the corresponding copied object.
 
struct  _DimensionGeometry
 Used in the dimension creation methods to indicate what geometry to create the dimension on.
 
struct  ConstraintGeometry
 Used by the create geometric constraint methods to indicate what geometry the constraint should be applied to. More...
 
struct  ConstraintGeometryHelp
 Used by several constraint creation methods that need a help point or parameter to indicate how to create the constraint. More...
 
struct  CopyObjectData
 This structure represents a map between the original object to be copied and the corresponding copied object. More...
 
struct  DimensionGeometry
 Used in the dimension creation methods to indicate what geometry to create the dimension on. More...
 

Public Types

enum  Status {
  Unknown, NotEvaluated, UnderConstrained, WellConstrained,
  OverConstrained, InconsistentlyConstrained
}
 Represents the status of the sketch More...
 
enum  ViewReorient { False, True }
 Used to indicate whether to reorient the view when the sketch is activated More...
 
enum  UpdateLevel { SketchOnly, Model }
 Used to indicate how much the updating should occur More...
 
enum  CreateInferConstraintSetting { On, Off }
 Indicates if the infer constraints will be created or not More...
 
enum  ConstraintPointType {
  None, StartVertex, EndVertex, ArcCenter,
  SplineDefiningPoint, Anchor, SplinePole, MidVertex
}
 Used in ConstraintGeometry to indicate what type of point, if any, the geometry is More...
 
enum  AssocType {
  None, StartPoint, EndPoint, ArcCenter,
  Tangency, CurvePoint, AnchorPoint, Midpoint
}
 Used in NXOpen.Sketch.DimensionGeometry to indicate what type of geometry to use More...
 
enum  ConstraintGeometryHelpType { Point, Parameter }
 Used in ConstraintHelp to indicate what type of help it is More...
 
enum  ConstraintClass { NotConstraint, Any, Geometric, Dimension }
 Represents the class of the constraint. More...
 
enum  ConstraintType {
  NoCon, Fixed, Horizontal, Vertical,
  Parallel, Perpendicular, Collinear, EqualLength,
  EqualRadius, ConstantLength, ConstantAngle, Coincident,
  Concentric, Mirror, PointOnCurve, Midpoint,
  Tangent, RadiusDim, DiameterDim, HorizontalDim,
  VerticalDim, ParallelDim, PerpendicularDim, AngularDim,
  ReservedCon1, ReservedCon2, ReservedCon3, ReservedCon4,
  ReservedCon5, ReservedCon6, PointOnString, Slope,
  UniformScaled, NonUniformScaled, AssocTrim, AssocOffset,
  PerimeterDim, Offset, Normal, PointOnLoop,
  RecipeTrim, Pattern, MinorAngularDim, MajorAngularDim,
  LastConType
}
 Represents the type of constraint More...
 
enum  DimensionOption { CreateAsDriving, CreateAsReference, CreateAsAutomatic }
 Used by NXOpen.Sketch.CreateDimension , NXOpen.Sketch.CreateRadialDimension NXOpen.Sketch.CreateDiameterDimension and NXOpen.Sketch.CreatePerimeterDimension to determine whether to create driving or reference dimension More...
 
enum  AutoDimensioningRule {
  Symmetric = 1, AdjacentAngle, Length, HorizontalVertical,
  ReferenceAxes
}
 Type of Auto Dimensioning rules. More...
 
enum  AddEllipseOption { TreatAsEllipse, TreatAsConic }
 Used by NXOpen.Sketch.AddGeometry to determine whether to treat an ellipse as an ellipse or generic conic when adding the curve to a sketch. More...
 
enum  TrimInputOption { False, True }
 Indicates whether the input curves should be trimmed when doing a fillet More...
 
enum  DeleteThirdCurveOption { False, True }
 Indicates whether the 3rd curve should be deleted when doing a 3 curve fillet More...
 
enum  CreateDimensionOption { False, True }
 Used in fillet to indicate whether a radius dimension should be created by the fillet More...
 
enum  AlternateSolutionOption { False, True }
 Indicates whether the alternate solution should be used instead of the regular solution. More...
 
enum  PlaneOption { Inferred, ExistingPlane, NewPlane, NewCsys }
 Specifies the plane type used for a Sketch More...
 
enum  InferConstraintsOption { InferNoConstraints, InferCoincidentConstraints }
 Used when adding a point or curve to a sketch. More...
 
- Public Types inherited from NXOpen.DisplayableObject
enum  ObjectWidth {
  Normal, Thick, Thin, One = 5,
  Two, Three, Four, Five,
  Six, Seven, Eight, Nine
}
 specifies object width for objects such as lines and text More...
 
enum  ObjectFont {
  Solid = 1, Dashed, Phantom, Centerline,
  Dotted, LongDashed, DottedDashed
}
 specifies the object font for objects such as lines More...
 
- Public Types inherited from NXOpen.NXObject
enum  AttributeType {
  Invalid, Null, Boolean, Integer,
  Real, String, Time, Reference,
  Any = 100
}
 Specifies attribute type. More...
 
enum  DateAndTimeFormat { Numeric, Textual }
 Specifies the format of the date and time attribute. More...
 

Public Member Functions

unsafe NXOpen.ErrorList DeleteObjects (NXOpen.NXObject[] objects)
 Deletes objects from the sketch More...
 
unsafe void Reattach (NXOpen.ISurface attachmentPlane, NXOpen.IReferenceAxis referenceAxis, NXOpen.Vector3d referenceDirection, NXOpen.AxisOrientation referenceAxisOrientation, NXOpen.Sense referenceAxisSense, NXOpen.PlaneNormalOrientation normalOrientation, NXOpen.Point3d localCoordinateSystemOrigin)
 Reattaches a sketch. More...
 
unsafe void Activate (NXOpen.Sketch.ViewReorient orientView)
 Activates the sketch More...
 
unsafe void Deactivate (NXOpen.Sketch.ViewReorient orientView, NXOpen.Sketch.UpdateLevel updateLevel)
 Deactivates the sketch More...
 
unsafe void SetReferenceDirection (NXOpen.IReferenceAxis referenceAxis, NXOpen.Vector3d referenceDirection, NXOpen.AxisOrientation referenceAxisOrientation, NXOpen.Sense referenceAxisSense)
 Sets the reference direction of the sketch. More...
 
unsafe void FlipReferenceDirection ()
 Flips the reference direction of the sketch More...
 
unsafe void FlipNormal ()
 Flips the outward normal vector of the sketch More...
 
unsafe NXOpen.Vector3d GetReferenceDirection (out NXOpen.IReferenceAxis referenceAxis, out NXOpen.AxisOrientation referenceAxisOrientation, out NXOpen.Sense referenceAxisSense)
 Gets the reference direction of the sketch More...
 
unsafe void RunAutoDimension ()
 Run auto dimensioning. More...
 
unsafe
NXOpen.SketchGeometricConstraint 
CreateCoincidentConstraint (NXOpen.Sketch.ConstraintGeometry geom1, NXOpen.Sketch.ConstraintGeometry geom2)
 Creates a coincident constraint More...
 
unsafe
NXOpen.SketchGeometricConstraint 
CreateFixedConstraint (NXOpen.Sketch.ConstraintGeometry geom)
 Creates a fixed constraint More...
 
unsafe
NXOpen.SketchGeometricConstraint[] 
CreateFullyFixedConstraints (NXOpen.Sketch.ConstraintGeometry geom)
 Creates enough fixed constraints on the curve and all of its vertices such that the geometry is fully fixed without any redundant fixed constraints. More...
 
unsafe
NXOpen.SketchGeometricConstraint 
CreateHorizontalConstraint (NXOpen.Sketch.ConstraintGeometry geom)
 Creates a horizontal constraint More...
 
unsafe
NXOpen.SketchGeometricConstraint 
CreateVerticalConstraint (NXOpen.Sketch.ConstraintGeometry geom)
 Creates a vertical constraint More...
 
unsafe
NXOpen.SketchTangentConstraint 
CreateTangentConstraint (NXOpen.Sketch.ConstraintGeometry geom1, NXOpen.Sketch.ConstraintGeometryHelp geom1Help, NXOpen.Sketch.ConstraintGeometry geom2, NXOpen.Sketch.ConstraintGeometryHelp geom2Help)
 Creates a tangent constraint. More...
 
unsafe
NXOpen.SketchGeometricConstraint 
CreateConstantLengthConstraint (NXOpen.Sketch.ConstraintGeometry conGeom)
 Creates a constant length constraint More...
 
unsafe
NXOpen.SketchGeometricConstraint 
CreateConstantAngleConstraint (NXOpen.Sketch.ConstraintGeometry conGeom)
 Creates a constant angle constraint More...
 
unsafe
NXOpen.SketchGeometricConstraint 
CreateUniformScaledConstraint (NXOpen.Sketch.ConstraintGeometry conGeom)
 Creates a uniform scale constraint More...
 
unsafe
NXOpen.SketchGeometricConstraint 
CreateNonUniformScaledConstraint (NXOpen.Sketch.ConstraintGeometry conGeom)
 Creates a non-uniform scale constraint More...
 
unsafe
NXOpen.SketchGeometricConstraint 
CreateParallelConstraint (NXOpen.Sketch.ConstraintGeometry conGeom1, NXOpen.Sketch.ConstraintGeometry conGeom2)
 Creates a parallel constraint. More...
 
unsafe
NXOpen.SketchGeometricConstraint 
CreatePerpendicularConstraint (NXOpen.Sketch.ConstraintGeometry conGeom1, NXOpen.Sketch.ConstraintGeometry conGeom2)
 Creates a perpendicular constraint. More...
 
unsafe
NXOpen.SketchGeometricConstraint 
CreateNormalConstraint (NXOpen.Sketch.ConstraintGeometry conGeom1, NXOpen.Sketch.ConstraintGeometryHelp geom1Help, NXOpen.Sketch.ConstraintGeometry conGeom2, NXOpen.Sketch.ConstraintGeometryHelp geom2Help)
 Creates a normal constraint. More...
 
unsafe
NXOpen.SketchGeometricConstraint 
CreateCollinearConstraint (NXOpen.Sketch.ConstraintGeometry conGeom1, NXOpen.Sketch.ConstraintGeometry conGeom2)
 Creates a collinear constraint. More...
 
unsafe
NXOpen.SketchGeometricConstraint 
CreateEqualLengthConstraint (NXOpen.Sketch.ConstraintGeometry conGeom1, NXOpen.Sketch.ConstraintGeometry conGeom2)
 Creates an equal length constraint. More...
 
unsafe
NXOpen.SketchGeometricConstraint 
CreateEqualRadiusConstraint (NXOpen.Sketch.ConstraintGeometry conGeom1, NXOpen.Sketch.ConstraintGeometry conGeom2)
 Creates an equal radius constraint. More...
 
unsafe
NXOpen.SketchGeometricConstraint 
CreateConcentricConstraint (NXOpen.Sketch.ConstraintGeometry conGeom1, NXOpen.Sketch.ConstraintGeometry conGeom2)
 Creates a concentric constraint. More...
 
unsafe
NXOpen.SketchGeometricConstraint 
CreateMidpointConstraint (NXOpen.Sketch.ConstraintGeometry conGeom1, NXOpen.Sketch.ConstraintGeometry conGeom2)
 Creates a midpoint constraint. More...
 
unsafe
NXOpen.SketchGeometricConstraint 
CreateSlopeConstraint (NXOpen.Sketch.ConstraintGeometry conGeom1, NXOpen.Sketch.ConstraintGeometry conGeom2)
 Creates a slope constraint. More...
 
unsafe
NXOpen.SketchHelpedGeometricConstraint 
CreatePointOnCurveConstraint (NXOpen.Sketch.ConstraintGeometry conGeom1, NXOpen.Sketch.ConstraintGeometry conGeom2, NXOpen.Sketch.ConstraintGeometryHelp help)
 Creates a point on curve constraint. More...
 
unsafe
NXOpen.SketchHelpedGeometricConstraint 
CreatePointOnStringConstraint (NXOpen.Sketch.ConstraintGeometry conGeom1, NXOpen.Curve[] curvesInString, NXOpen.Sketch.ConstraintGeometryHelp helpData, int curveWhichHelpParamAppliesTo)
 Creates a point on string constraint. More...
 
unsafe
NXOpen.SketchHelpedGeometricConstraint 
CreatePointOnStringConstraint (NXOpen.Sketch.ConstraintGeometry conGeom1, NXOpen.Curve curveInString, NXOpen.Sketch.ConstraintGeometryHelp helpData)
 Creates a point on string constraint. More...
 
unsafe
NXOpen.SketchDimensionalConstraint 
CreateDimension (NXOpen.Sketch.ConstraintType dimType, NXOpen.Sketch.DimensionGeometry dimObject1, NXOpen.Sketch.DimensionGeometry dimObject2, NXOpen.Point3d dimOrigin, NXOpen.Expression expression)
 Creates a dimension between two geometric objects. More...
 
unsafe
NXOpen.SketchDimensionalConstraint 
CreateDimension (NXOpen.Sketch.ConstraintType dimType, NXOpen.Sketch.DimensionGeometry dimObject1, NXOpen.Sketch.DimensionGeometry dimObject2, NXOpen.Point3d dimOrigin, NXOpen.Expression expression, NXOpen.Sketch.DimensionOption refDim)
 Creates a dimension between two geometric objects. More...
 
unsafe
NXOpen.SketchDimensionalConstraint 
CreateRadialDimension (NXOpen.Sketch.DimensionGeometry dimObject1, NXOpen.Point3d dimOrigin, NXOpen.Expression expression)
 Creates a radial dimension constraint More...
 
unsafe
NXOpen.SketchDimensionalConstraint 
CreateRadialDimension (NXOpen.Sketch.DimensionGeometry dimObject1, NXOpen.Point3d dimOrigin, NXOpen.Expression expression, NXOpen.Sketch.DimensionOption refDim)
 Creates a radial dimension constraint. More...
 
unsafe
NXOpen.SketchDimensionalConstraint 
CreateDiameterDimension (NXOpen.Sketch.DimensionGeometry dimObject1, NXOpen.Point3d dimOrigin, NXOpen.Expression expression)
 Creates a diameter dimension constraint More...
 
unsafe
NXOpen.SketchDimensionalConstraint 
CreateDiameterDimension (NXOpen.Sketch.DimensionGeometry dimObject1, NXOpen.Point3d dimOrigin, NXOpen.Expression expression, NXOpen.Sketch.DimensionOption refDim)
 Creates a diameter dimension constraint. More...
 
unsafe
NXOpen.SketchDimensionalConstraint 
CreatePerimeterDimension (NXOpen.Curve[] curves, NXOpen.Point3d dimOrigin, NXOpen.Expression expression)
 Creates a perimeter dimension constraint More...
 
unsafe void LocalUpdate ()
 Update the sketch and not the sketch children. More...
 
unsafe void Update ()
 Updates the sketch More...
 
unsafe void Update (NXOpen.NXObject[] geoms)
 Updates the given set of geometries in the sketch More...
 
unsafe void UpdateGeometryDisplay ()
 Updates the geometry display without updating the sketch More...
 
unsafe void UpdateGeometryDisplay (NXOpen.SmartObject[] geoms)
 Updates the geometry display of given set of geoms without updating the sketch More...
 
unsafe void UpdateDimensionDisplay ()
 Updates the dimension display without updating the sketch More...
 
unsafe void UpdateDimensionDisplay (NXOpen.SmartObject[] geoms)
 Updates the dimension display of given set of geoms without updating the sketch More...
 
unsafe void UpdateDimensionDisplay (NXOpen.NXObject[] dims)
 Updates the dimension display of given set of dims without updating the sketch More...
 
unsafe void UpdateConstraintDisplay ()
 Updates the constraint display without updating the sketch More...
 
unsafe void UpdateConstraintDisplay (NXOpen.SmartObject[] geoms)
 Updates the constraint display of given set of geoms without updating the sketch More...
 
unsafe void AddGeometry (NXOpen.DisplayableObject crv, NXOpen.Sketch.InferConstraintsOption inferCoincidentConstraints)
 Adds a curve or point to the sketch More...
 
unsafe void AddGeometry (NXOpen.DisplayableObject crv)
 Adds a curve or point to the sketch. More...
 
unsafe void AddGeometry (NXOpen.Curve crv, NXOpen.Sketch.InferConstraintsOption inferCoincidentConstraints, NXOpen.Sketch.AddEllipseOption ellipseOption)
 Adds a curve or point to a sketch. More...
 
unsafe void AddGeometry (NXOpen.Sketch.InferConstraintsOption inferCoincidentConstraints, NXOpen.Sketch.AddEllipseOption ellipseOption, NXOpen.SmartObject[] curvesOrPoints)
 Adds an array of curves or points to a sketch. More...
 
unsafe NXOpen.Sketch.Status GetStatus (out int dofNeeded)
 Gets the status of the sketch and the number of degrees of freedom that remain in the sketch. More...
 
unsafe NXOpen.SketchConstraint[] GetAllConstraintsOfType (NXOpen.Sketch.ConstraintClass conClass, NXOpen.Sketch.ConstraintType conType)
 Gets all constraints in the sketch of a particular type More...
 
unsafe NXOpen.SketchConstraint[] GetConstraintsForGeometry (NXOpen.SmartObject geometry, NXOpen.Sketch.ConstraintClass conClass)
 Gets all the constraints associated with a particular geometric item More...
 
unsafe NXOpen.Expression[] GetAllExpressions ()
 Returns all the expressions in the sketch More...
 
unsafe NXOpen.NXObject[] GetAllGeometry ()
 Returns all the curves and points in the sketch More...
 
unsafe NXOpen.Arc[] Fillet (NXOpen.Curve curve1, NXOpen.Curve curve2, NXOpen.Point3d helpPoint1, NXOpen.Point3d helpPoint2, double radius, NXOpen.Sketch.TrimInputOption doTrim, NXOpen.Sketch.CreateDimensionOption createRadiusDim, NXOpen.Sketch.AlternateSolutionOption alternateSolution, out NXOpen.SketchConstraint[] constraints)
 Fillets curves and creates appropriate constraints. More...
 
unsafe NXOpen.Arc[] Fillet (NXOpen.Curve curve1, NXOpen.Curve curve2, NXOpen.Point3d helpPoint1, NXOpen.Point3d helpPoint2, NXOpen.Point3d pointOnArc, double radius, NXOpen.Sketch.TrimInputOption doTrim, NXOpen.Sketch.CreateDimensionOption createRadiusDim, NXOpen.Sketch.AlternateSolutionOption alternateSolution, out NXOpen.SketchConstraint[] constraints)
 Fillets curves and creates appropriate constraints. More...
 
unsafe NXOpen.Arc[] Fillet (NXOpen.Curve curve1, NXOpen.Curve curve2, NXOpen.Curve curve3, NXOpen.Point3d helpPoint1, NXOpen.Point3d helpPoint2, NXOpen.Point3d helpPoint3, double radius, NXOpen.Sketch.TrimInputOption doTrim, NXOpen.Sketch.DeleteThirdCurveOption doDelete, NXOpen.Sketch.CreateDimensionOption createRadiusDim, NXOpen.Sketch.AlternateSolutionOption alternateSolution, out NXOpen.SketchConstraint[] constraints)
 Fillets curves and creates appropriate constraints. More...
 
unsafe NXOpen.Arc[] Fillet (NXOpen.Curve curve1, NXOpen.Curve curve2, NXOpen.Curve curve3, NXOpen.Point3d helpPoint1, NXOpen.Point3d helpPoint2, NXOpen.Point3d helpPoint3, NXOpen.Point3d pointOnArc, double radius, NXOpen.Sketch.TrimInputOption doTrim, NXOpen.Sketch.DeleteThirdCurveOption doDelete, NXOpen.Sketch.CreateDimensionOption createRadiusDim, NXOpen.Sketch.AlternateSolutionOption alternateSolution, out NXOpen.SketchConstraint[] constraints)
 Fillets curves and creates appropriate constraints. More...
 
unsafe void DeleteConstraintsOnGeometries (NXOpen.NXObject[] objects)
 Deletes all geometric constraints associated with the object and all of its vertices. More...
 
unsafe void DeleteConstraintsOnGeometries (NXOpen.Sketch.ConstraintGeometry[] objects)
 Deletes all geometric constraints associated with the object and all of its vertices. More...
 
unsafe void DeleteConstraintsOnGeometries (NXOpen.Sketch.ConstraintClass conClass, NXOpen.Sketch.ConstraintGeometry[] objects)
 Deletes constraints associated with the input sketch geometry and vertices according to the constraint class, e. More...
 
unsafe NXOpen.NXObject[] CopyObjects (NXOpen.NXObject[] inputObjects)
 Creates copies of input objects and constraints between these objects. More...
 
unsafe void CopyObjectsWithDimensionOutput (NXOpen.NXObject[] inputObjects, out NXOpen.NXObject[] outputObjects, out NXOpen.NXObject[] outputDims)
 Creates copies of input objects and constraints between these objects. More...
 
unsafe void ShowDimensions (NXOpen.DisplayableObject[] inputObjects)
 Unblanks dimensions in the active sketch associated with the input sketch geometry More...
 
unsafe void HideDimensions (NXOpen.DisplayableObject[] inputObjects)
 Blanks dimensions in the active sketch associated with the input sketch geometry. More...
 
unsafe void ShowDimensions ()
 Unblanks all the dimensions of input sketch More...
 
unsafe void ShowDimensions (NXOpen.Sketch.ConstraintGeometry[] objects)
 Unblanks dimensions in the active sketch associated with the input sketch geometry. More...
 
unsafe void HideDimensions ()
 Blanks all the dimensions of input sketch More...
 
unsafe void HideDimensions (NXOpen.Sketch.ConstraintGeometry[] objects)
 Blanks dimensions in the active sketch associated with the input sketch geometry. More...
 
unsafe NXOpen.SketchConstraint[] AutoConstrain (double linearTolerance, double angularTolerance, bool allowRemoteConstraints, NXOpen.SmartObject[] geometries, NXOpen.Sketch.ConstraintType[] autoconstraintTypes)
 Creates Automatic Constraints on input set of geometries. More...
 
unsafe void MakeDatumsInternal ()
 Makes the sketch placement face and directional reference internal to the sketch if they are both datums referenced only by the sketch. More...
 
unsafe void MakeDatumsExternal ()
 Makes the internal sketch placement face and directional reference datums external. More...
 
unsafe void MakeDatumsExternal2 ()
 Makes the internal sketch placement face and directional reference datums external. More...
 
unsafe
NXOpen.Sketch.CopyObjectData[] 
CopyObjectsWithTracking (NXOpen.DisplayableObject[] inputObjects)
 Creates copies of input objects and constraints between these objects. More...
 
unsafe void EditSplinePoles (NXOpen.Spline spline, double[] poles)
 Changes the locations of the control poles of a spline. More...
 
unsafe void EditSplineDefiningPoints (NXOpen.Spline spline, double[] points)
 Changes the locations of the defining points of a spline. More...
 
unsafe void ConvertToNx10Spline (NXOpen.Spline spline)
 Convert the legacy splines to new NX10 splines. More...
 
unsafe void RemoveRedundantVertices (NXOpen.NXObject[] geoms)
 Remove redundant vertices of the given sketch geometry More...
 
unsafe void ManageConstraintsAfterEdit (NXOpen.NXObject[] sketchGeoms, bool preserveComplexConstraints)
 Deletes or adjusts constraints of the input geometry that are incompatible after geometry edit. More...
 
unsafe void BreakAssociativity (NXOpen.NXObject[] sketchGeoms)
 Breaks associativity of recipe geometry (projected or intersection curves and points) in the sketch, making the curves regular sketch geometry. More...
 
unsafe void Scale (double scaleFactor)
 Scale the sketch entities by the given scale factor. More...
 
- Public Member Functions inherited from NXOpen.DisplayableObject
unsafe void Blank ()
 Blanks the object. More...
 
unsafe void Unblank ()
 Unblanks the object. More...
 
unsafe void Highlight ()
 Highlights the object. More...
 
unsafe void Unhighlight ()
 Unhighlights the object. More...
 
unsafe void SetNameLocation (NXOpen.Point3d location)
 Sets the location of the object's name. More...
 
unsafe void RedisplayObject ()
 Redisplays the object in all views. More...
 
unsafe void RemoveViewDependency ()
 Remove dependency on all views from an object. More...
 
- Public Member Functions inherited from NXOpen.NXObject
unsafe void SetUserAttribute (NXOpen.NXObject.AttributeInformation info, NXOpen.Update.Option option)
 Creates or modifies an attribute with the option to update or not. More...
 
unsafe void SetUserAttribute (string title, int index, int value, NXOpen.Update.Option option)
 Creates or modifies an integer attribute with the option to update or not. More...
 
unsafe void SetUserAttribute (string title, int index, double value, NXOpen.Update.Option option)
 Creates or modifies a real attribute with the option to update or not. More...
 
unsafe void SetUserAttribute (string title, int index, string value, NXOpen.Update.Option option)
 Creates or modifies a string attribute with the option to update or not. More...
 
unsafe void SetUserAttribute (string title, int index, NXOpen.Update.Option option)
 Creates or modifies a null attribute with the option to update or not. More...
 
unsafe void SetTimeUserAttribute (string title, int index, string value, NXOpen.Update.Option option)
 Creates or modifies a time attribute with the option to update or not. More...
 
unsafe void SetTimeUserAttribute (string title, int index, NXOpen.NXObject.ComputationalTime value, NXOpen.Update.Option option)
 Creates or modifies a time attribute with the option to update or not. More...
 
unsafe void SetBooleanUserAttribute (string title, int index, bool value, NXOpen.Update.Option option)
 Creates or modifies a boolean attribute with the option to update or not. More...
 
unsafe NXOpen.AttributeIterator CreateAttributeIterator ()
 Create an attribute iterator More...
 
unsafe bool HasUserAttribute (NXOpen.AttributeIterator iterator)
 Determines if an attribute exists on the object, that satisfies the given iterator More...
 
unsafe bool HasUserAttribute (string title, NXOpen.NXObject.AttributeType type, int index)
 Determines if an attribute with the given Title, Type and array Index is present on the object Unset attributes will not be detected by this function, as its purpose is to test for the actual presence of the attribute on the object. More...
 
unsafe int GetUserAttributeCount (NXOpen.AttributeIterator iterator)
 Gets the count of set attributes on the object, if any, that satisfy the given iterator. More...
 
unsafe int GetUserAttributeCount (NXOpen.AttributeIterator iterator, bool countArrayAsOneAttribute)
 Gets the count of set attributes on the object, if any, that satisfy the given iterator. More...
 
unsafe int GetUserAttributeCount (NXOpen.NXObject.AttributeType type)
 Gets the count of set attributes on the object, if any, of the given type. More...
 
unsafe int GetUserAttributeCount (NXOpen.NXObject.AttributeType type, bool includeUnset, bool countArrayAsOneAttribute)
 Gets the count of attributes on the object, if any, of the given type. More...
 
unsafe int GetUserAttributeSize (string title, NXOpen.NXObject.AttributeType type)
 Gets the size of the first attribute encountered on the object, if any, with a given Title and Type. More...
 
unsafe bool GetNextUserAttribute (NXOpen.AttributeIterator iterator, out NXOpen.NXObject.AttributeInformation info)
 Gets the next attribute encountered on the object, if any, that satisfies the given iterator. More...
 
unsafe
NXOpen.NXObject.AttributeInformation 
GetUserAttribute (string title, NXOpen.NXObject.AttributeType type, int index)
 Gets the first attribute encountered on the object, if any, with a given Title, Type and array Index. More...
 
unsafe bool GetBooleanUserAttribute (string title, int index)
 Gets a boolean attribute by Title and array Index. More...
 
unsafe int GetIntegerUserAttribute (string title, int index)
 Gets an integer attribute by Title and array Index. More...
 
unsafe double GetRealUserAttribute (string title, int index)
 Gets a real attribute by Title and array Index. More...
 
unsafe string GetStringUserAttribute (string title, int index)
 Gets a string attribute by Title and array Index. More...
 
unsafe string GetTimeUserAttribute (string title, int index)
 Gets a time attribute by Title and array Index. More...
 
unsafe
NXOpen.NXObject.ComputationalTime 
GetComputationalTimeUserAttribute (string title, int index)
 Gets a time attribute by Title and array Index. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttributes (NXOpen.AttributeIterator iterator)
 Gets all the attributes that have been set on the given object, if any, that satisfy the given iterator. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttributes ()
 Gets all the attributes that have been set on the given object. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttributes (bool includeUnset)
 Gets all the attributes of the given object. More...
 
unsafe string GetUserAttributeAsString (string title, NXOpen.NXObject.AttributeType type, int index)
 Gets the first attribute encountered on the object, if any, with a given title, type and array index. More...
 
unsafe void DeleteUserAttributes (NXOpen.AttributeIterator iterator, NXOpen.Update.Option option)
 Deletes the attributes on the object, if any, that satisfy the given iterator More...
 
unsafe void DeleteUserAttribute (NXOpen.NXObject.AttributeType type, string title, bool deleteEntireArray, NXOpen.Update.Option option)
 Deletes the first attribute encountered with the given Type, Title. More...
 
unsafe void DeleteUserAttributes (NXOpen.NXObject.AttributeType type, NXOpen.Update.Option option)
 Deletes the attributes encountered with the given Type with option to update or not. More...
 
unsafe void SetUserAttributeLock (string title, NXOpen.NXObject.AttributeType type, bool @lock)
 Lock or unlock the given attribute. More...
 
unsafe bool GetUserAttributeLock (string title, NXOpen.NXObject.AttributeType type)
 Determine the lock of the given attribute. More...
 
unsafe NXOpen.NXObject[] GetUserAttributeSourceObjects ()
 Returns an array of objects from which this object presents attributes. More...
 
unsafe void SetPdmReferenceAttribute (string attributeTitle, string attributeValue)
 Sets the value of PDM Reference attribute on the object. More...
 
unsafe string GetPdmReferenceAttributeValue (string attributeTitle)
 Gets the value of PDM Reference attribute for given object. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttribute (string title, bool includeUnset, bool addStringValues, NXOpen.NXObject.AttributeType type)
 Gets the first attribute (or attribute array) encountered on the object, if any, with a given Title and Type. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttributes (bool includeUnset, bool addStringValues)
 Gets all the attributes of the given object. More...
 
unsafe void DeleteAllAttributesByType (NXOpen.NXObject.AttributeType type)
 Deletes all attributes of a specific type. More...
 
unsafe void DeleteAllAttributesByType (NXOpen.NXObject.AttributeType type, NXOpen.Update.Option option)
 Deletes all attributes of a specific type with the option to update or not. More...
 
unsafe void SetAttribute (string title, int value)
 Creates or modifies an integer attribute. More...
 
unsafe void SetAttribute (string title, int value, NXOpen.Update.Option option)
 Creates or modifies an integer attribute with the option to update or not. More...
 
unsafe void SetAttribute (string title, double value)
 Creates or modifies a real attribute. More...
 
unsafe void SetAttribute (string title, double value, NXOpen.Update.Option option)
 Creates or modifies a real attribute with the option to update or not. More...
 
unsafe void SetAttribute (string title, string value)
 Creates or modifies a string attribute. More...
 
unsafe void SetAttribute (string title, string value, NXOpen.Update.Option option)
 Creates or modifies a string attribute with the option to update or not. More...
 
unsafe void SetAttribute (string title)
 Creates or modifies a null attribute which is an attribute with a title and no value. More...
 
unsafe void SetAttribute (string title, NXOpen.Update.Option option)
 Creates or modifies a null attribute with the option to update or not. More...
 
unsafe void SetTimeAttribute (string title, string value)
 Creates or modifies a time attribute. More...
 
unsafe void SetTimeAttribute (string title, string value, NXOpen.Update.Option option)
 Creates or modifies a time attribute with the option to update or not. More...
 
unsafe int GetIntegerAttribute (string title)
 Gets an integer attribute by title. More...
 
unsafe double GetRealAttribute (string title)
 Gets a real attribute by title. More...
 
unsafe string GetStringAttribute (string title)
 Gets a string attribute value by title. More...
 
unsafe string GetTimeAttribute (NXOpen.NXObject.DateAndTimeFormat format, string title)
 Gets a time attribute by title. More...
 
unsafe string GetReferenceAttribute (string title)
 Gets the reference string (not the calculated value) of a string attribute that uses a reference string. More...
 
unsafe void DeleteAttributeByTypeAndTitle (NXOpen.NXObject.AttributeType type, string title)
 Deletes an attribute by type and title. More...
 
unsafe void DeleteAttributeByTypeAndTitle (NXOpen.NXObject.AttributeType type, string title, NXOpen.Update.Option option)
 Deletes an attribute by type and title with the option to update or not. More...
 
unsafe void SetReferenceAttribute (string title, string value)
 Creates or modifies a string attribute which uses a reference string. More...
 
unsafe void SetReferenceAttribute (string title, string value, NXOpen.Update.Option option)
 Creates or modifies a string attribute which uses a reference string, with the option to update or not. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetAttributeTitlesByType (NXOpen.NXObject.AttributeType type)
 Gets all the attribute titles of a specific type. More...
 
unsafe string[] GetUserAttributesAsStrings ()
 Gets all the attributes that have been set on the given object. More...
 
unsafe NXOpen.INXObject FindObject (string journalIdentifier)
 Finds the NXOpen.NXObject with the given identifier as recorded in a journal. More...
 
unsafe void Print ()
 Prints a representation of this object to the system log file. More...
 
unsafe void SetName (string name)
 Sets the custom name of the object. More...
 

Properties

NXOpen.Preferences.SketchPreferences Preferences [get]
 Contains preferences for the sketch More...
 
unsafe NXOpen.ISurface AttachPlane [get]
 Returns the plane that the sketch is attached to More...
 
unsafe
NXOpen.Sketch.CreateInferConstraintSetting 
CreateInferConstraintsSetting [get, set]
 Returns or sets the toggle that controls the creation of infer constraints in sketch More...
 
unsafe bool DOFDisplay [get, set]
 Returns or sets a flag indicating whether the degree of freedom arrows are currently being displayed More...
 
unsafe NXOpen.Features.Feature Feature [get]
 Returns the feature associated with this sketch More...
 
unsafe bool IsActive [get]
 Returns true if the sketch is active More...
 
unsafe bool IsDraftingSketch [get]
 Returns true if drafting sketch More...
 
unsafe bool IsInternal [get]
 Returns true if the sketch is internal. More...
 
unsafe NXOpen.NXMatrix Orientation [get]
 Returns the orientation matrix of the local coordinate system of the sketch More...
 
unsafe NXOpen.Point3d Origin [get]
 Returns the location of the origin of the local coordinate system for the sketch More...
 
unsafe NXOpen.Sketch.UpdateLevel UpdateScope [get, set]
 Returns or sets the current update scope. More...
 
unsafe NXOpen.View View [get]
 Returns the view corresponding to sketch More...
 
- Properties inherited from NXOpen.DisplayableObject
unsafe int Color [get, set]
 Returns or sets the color of the object. More...
 
unsafe bool IsBlanked [get]
 Returns the blank status of this object. More...
 
unsafe int Layer [get, set]
 Returns or sets the layer that the object is in. More...
 
unsafe
NXOpen.DisplayableObject.ObjectFont 
LineFont [get, set]
 Returns or sets the line font of the object. More...
 
unsafe
NXOpen.DisplayableObject.ObjectWidth 
LineWidth [get, set]
 Returns or sets the line width of the object. More...
 
unsafe NXOpen.Point3d NameLocation [get]
 Returns the location of the object's name. More...
 
- Properties inherited from NXOpen.NXObject
unsafe bool IsOccurrence [get]
 Returns whether this object is an occurrence or not. More...
 
unsafe string JournalIdentifier [get]
 Returns the identifier that would be recorded in a journal for this object. More...
 
unsafe string Name [get]
 Returns the custom name of the object. More...
 
unsafe NXOpen.Assemblies.Component OwningComponent [get]
 Returns the owning component, if this object is an occurrence. More...
 
unsafe NXOpen.BasePart OwningPart [get]
 Returns the owning part of this object More...
 
unsafe NXOpen.INXObject Prototype [get]
 Returns the prototype of this object if it is an occurrence. More...
 
- Properties inherited from NXOpen.INXObject
bool IsOccurrence [get]
 Returns whether this object is an occurrence or not. More...
 
string JournalIdentifier [get]
 Returns the identifier that would be recorded in a journal for this object. More...
 
string Name [get]
 Returns the custom name of the object. More...
 
NXOpen.Assemblies.Component OwningComponent [get]
 Returns the owning component, if this object is an occurrence. More...
 
NXOpen.BasePart OwningPart [get]
 Returns the owning part of this object More...
 
NXOpen.INXObject Prototype [get]
 Returns the prototype of this object if it is an occurrence. More...
 

Detailed Description

Represents a sketch

Use the NXOpen.SketchCollection class to create a sketch.

Created in NX3.0.0

Member Enumeration Documentation

Used by NXOpen.Sketch.AddGeometry to determine whether to treat an ellipse as an ellipse or generic conic when adding the curve to a sketch.

Treating an ellipse as a conic means that the ellipse will be given an anchor point. This affects, among other things, how the ellipse behaves when it is dragged.

In order for an ellipse to be treated as a conic, its end angle minus its start angle must be less than 180 degrees.

Enumerator
TreatAsEllipse 
TreatAsConic 

Indicates whether the alternate solution should be used instead of the regular solution.

The alternate solution for an arc is the portion of the full circle that is left out of the regular solution. For example, if the regular solution is an arc that goes from 0 to 45 degrees, the alternate solution will be an arc with the same center and origin but that goes from 45 degrees to 360.

Enumerator
False 

Use the regular solution

True 

Use the alternate solution

Used in NXOpen.Sketch.DimensionGeometry to indicate what type of geometry to use

Enumerator
None 

Use the entire geometric item, as opposed to a point

StartPoint 

Start point.

E.g. the start point of a line

EndPoint 

End point.

E.g. the start point of a line

ArcCenter 

Center of an arc, circle, or ellipse

Tangency 

Create the dimension tangent to the geometric item

CurvePoint 

A point on a spline

AnchorPoint 

The anchor of a conic

Midpoint 

The midpoint of a curve

Type of Auto Dimensioning rules.

It should match the rule types defined in Auto Dimensioning engine. Auto Dimensioning rules affect how the dimensions are created by the Auto Dimensioner. The rules will be put in a list, the first the rule with the highest priority and the last rule with the lowest priority. The user can change the order of the rules in the list to persue the flavor of the dimensions he wants. NXOpen.Sketch.AutoDimensioningRule.Symmetric : create symmetric dimensions if the curves are symmetric NXOpen.Sketch.AutoDimensioningRule.AdjacentAngle : create angles between adjacent lines NXOpen.Sketch.AutoDimensioningRule.Length : create length dimension for lines NXOpen.Sketch.AutoDimensioningRule.HorizontalVertical : create horizontal and vertical dimensions NXOpen.Sketch.AutoDimensioningRule.ReferenceAxes : create dimensions between curves and reference axes

Enumerator
Symmetric 

Create Symmetric Dimensions

AdjacentAngle 

Create Adjacent Angles

Length 

Create Length Dimension

HorizontalVertical 

Create Horizontal and Vertical Dimensions

ReferenceAxes 

Create Dimensions to Reference Axes

Represents the class of the constraint.

There are two classes of constraints: geometric and dimension

Enumerator
NotConstraint 
Any 

Used in query methods that filter by constraint class to select both types of constraints

Geometric 

A non-dimension constraint

Dimension 

A dimensional constraint

Used in ConstraintHelp to indicate what type of help it is

Enumerator
Point 
Parameter 

Used in ConstraintGeometry to indicate what type of point, if any, the geometry is

Enumerator
None 

The geometry is not a point

StartVertex 

Start vertex (e.g.

the start point of a line)

EndVertex 

End vertex (e.g.

the end point of a line)

ArcCenter 

Center of a circle, arc, or ellipse

SplineDefiningPoint 

A defining point of a spline.

Anchor 

The anchor point of a conic

SplinePole 

The control pole of a spline

MidVertex 

The mid vertex of a line or an arc

Represents the type of constraint

Enumerator
NoCon 

Used in query methods that filter by constraint type to select any type of constraint

Fixed 
Horizontal 
Vertical 
Parallel 
Perpendicular 
Collinear 
EqualLength 
EqualRadius 
ConstantLength 
ConstantAngle 
Coincident 
Concentric 
Mirror 
PointOnCurve 
Midpoint 
Tangent 
RadiusDim 
DiameterDim 
HorizontalDim 
VerticalDim 
ParallelDim 
PerpendicularDim 
AngularDim 

system will decide if it is major or minor

ReservedCon1 

Do not use

ReservedCon2 

Do not use

ReservedCon3 

Do not use

ReservedCon4 

Do not use

ReservedCon5 

Do not use

ReservedCon6 

Do not use

PointOnString 
Slope 
UniformScaled 
NonUniformScaled 
AssocTrim 

Limited support

AssocOffset 

Limited support

PerimeterDim 
Offset 
Normal 
PointOnLoop 
RecipeTrim 
Pattern 
MinorAngularDim 
MajorAngularDim 
LastConType 

The last constraint type indicator; NOT to be used.

Used in fillet to indicate whether a radius dimension should be created by the fillet

Enumerator
False 

Do not create a radius dimension

True 

Create a radius dimension

Indicates if the infer constraints will be created or not

Enumerator
On 

Create infer constraints

Off 

Dont create infer constraints

Indicates whether the 3rd curve should be deleted when doing a 3 curve fillet

Enumerator
False 

Do not delete the 3rd curve

True 

Delete the 3rd curve

Used by NXOpen.Sketch.CreateDimension , NXOpen.Sketch.CreateRadialDimension NXOpen.Sketch.CreateDiameterDimension and NXOpen.Sketch.CreatePerimeterDimension to determine whether to create driving or reference dimension

Enumerator
CreateAsDriving 

Create dimension as driving

CreateAsReference 

Create dimension as reference

CreateAsAutomatic 

Create dimension as automatic

Used when adding a point or curve to a sketch.

Specifies whether to infer coincident constraints between the geometry that already exists in the sketch and the geometry being added to the sketch. If you choose to infer constraints, coincident constraints will be created if an end point of the geometry being added is at the same location (within system tolerance) as another end point in the sketch.

Enumerator
InferNoConstraints 

Do not infer constraints

InferCoincidentConstraints 

Infer constraints

Specifies the plane type used for a Sketch

Enumerator
Inferred 

Use inferred plane

ExistingPlane 

Use existing plane

NewPlane 

Use new plane

NewCsys 

Use new CSYS

Represents the status of the sketch

Enumerator
Unknown 
NotEvaluated 
UnderConstrained 

More constraints are needed to fully constrain the sketch

WellConstrained 

The sketch is fully constrained

OverConstrained 

The sketch has more constraints than is needed

InconsistentlyConstrained 

The sketch has conflicting constraints

Indicates whether the input curves should be trimmed when doing a fillet

Enumerator
False 

Do not trim the input curves

True 

Trim the input curves

Used to indicate how much the updating should occur

Enumerator
SketchOnly 

Only update the sketch

Model 

Update the full model and the sketch

Used to indicate whether to reorient the view when the sketch is activated

Enumerator
False 

Do not reorient view to sketch

True 

Reorient view to sketch

Member Function Documentation

unsafe void NXOpen.Sketch.Activate ( NXOpen.Sketch.ViewReorient  orientView)

Activates the sketch

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
orientViewIndicates whether to orient the view to the sketch during activation
unsafe void NXOpen.Sketch.AddGeometry ( NXOpen.DisplayableObject  crv,
NXOpen.Sketch.InferConstraintsOption  inferCoincidentConstraints 
)

Adds a curve or point to the sketch

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
crvMust be a curve or point
inferCoincidentConstraintsWhether to automatically create coincident constraints when adding the geometry. If this flag is true and there exists another curve or point in the sketch that has a vertex that is at the same location (within system tolerance) as one of the vertices for crv, a coincident constraint will be created
unsafe void NXOpen.Sketch.AddGeometry ( NXOpen.DisplayableObject  crv)

Adds a curve or point to the sketch.

Infers coincident constraints with other geometry in the sketch

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
crvMust be a curve or point
unsafe void NXOpen.Sketch.AddGeometry ( NXOpen.Curve  crv,
NXOpen.Sketch.InferConstraintsOption  inferCoincidentConstraints,
NXOpen.Sketch.AddEllipseOption  ellipseOption 
)

Adds a curve or point to a sketch.

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
crvMust be a curve or point
inferCoincidentConstraintsWhether to automatically create coincident constraints when adding the geometry. If this flag is true and there exists another curve or point in the sketch that has a vertex that is at the same location (within system tolerance) as one of the vertices for crv, a coincident constraint will be created
ellipseOptionIf you are adding an ellipse to the sketch, this parameter indicates whether the ellipse should be treated as an ellipse or general conic. If you are not adding an ellipse, the option is ignored. See the documentation for NXOpen.Sketch.AddEllipseOption for more details. The default value is NXOpen.Sketch.AddEllipseOption.TreatAsEllipse . In order to treat an ellipse as a conic, its end angle minus its start angle must be less than 180 degrees.
unsafe void NXOpen.Sketch.AddGeometry ( NXOpen.Sketch.InferConstraintsOption  inferCoincidentConstraints,
NXOpen.Sketch.AddEllipseOption  ellipseOption,
NXOpen.SmartObject[]  curvesOrPoints 
)

Adds an array of curves or points to a sketch.

Created in NX6.0.1

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
inferCoincidentConstraintsWhether to automatically create coincident constraints when adding the geometry. If this flag is true and there exists another curve or point in the sketch that has a vertex that is at the same location (within system tolerance) as one of the vertices for crv, a coincident constraint will be created
ellipseOptionIf you are adding an ellipse to the sketch, this parameter indicates whether the ellipse should be treated as an ellipse or general conic. If you are not adding an ellipse, the option is ignored. See the documentation for NXOpen.Sketch.AddEllipseOption for more details. The default value is NXOpen.Sketch.AddEllipseOption.TreatAsEllipse . In order to treat an ellipse as a conic, its end angle minus its start angle must be less than 180 degrees.
curvesOrPointsMust be a curve or point
unsafe NXOpen.SketchConstraint [] NXOpen.Sketch.AutoConstrain ( double  linearTolerance,
double  angularTolerance,
bool  allowRemoteConstraints,
NXOpen.SmartObject[]  geometries,
NXOpen.Sketch.ConstraintType[]  autoconstraintTypes 
)

Creates Automatic Constraints on input set of geometries.

Created in NX4.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
linearToleranceCapture Distance
angularToleranceCapture Angle
allowRemoteConstraintsAllow remote constraints
geometriesArray of geometries
autoconstraintTypesConstraint type array
Returns
Array of deduced constraints
unsafe void NXOpen.Sketch.BreakAssociativity ( NXOpen.NXObject[]  sketchGeoms)

Breaks associativity of recipe geometry (projected or intersection curves and points) in the sketch, making the curves regular sketch geometry.

Any non-recipe geometry is ignored. Call this before sketch update.

Created in NX11.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
sketchGeomsRecipe geometry in the active sketch
unsafe void NXOpen.Sketch.ConvertToNx10Spline ( NXOpen.Spline  spline)

Convert the legacy splines to new NX10 splines.

The input spline will be upgraded to NX10 spline. No new splines will be created to replace the input spline.

Created in NX10.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
spline
unsafe NXOpen.NXObject [] NXOpen.Sketch.CopyObjects ( NXOpen.NXObject[]  inputObjects)

Creates copies of input objects and constraints between these objects.

Created in NX4.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
inputObjectsObjects to be copied
Returns
Copies of objects
unsafe void NXOpen.Sketch.CopyObjectsWithDimensionOutput ( NXOpen.NXObject[]  inputObjects,
out NXOpen.NXObject[]  outputObjects,
out NXOpen.NXObject[]  outputDims 
)

Creates copies of input objects and constraints between these objects.

This function is same as NXOpen.Sketch.CopyObjects except that it returns an array of newly created dimensions

Created in NX6.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
inputObjectsObjects to be copied
outputObjectsCopies of objects
outputDimsCopies of dims
unsafe NXOpen.Sketch.CopyObjectData [] NXOpen.Sketch.CopyObjectsWithTracking ( NXOpen.DisplayableObject[]  inputObjects)

Creates copies of input objects and constraints between these objects.

Sketch dimensions are copied only if explicitly included in the input_objects array.

Created in NX7.5.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
inputObjectsObjects to be copied
Returns
Map between the original input object and the corresponding copied object
unsafe NXOpen.SketchGeometricConstraint NXOpen.Sketch.CreateCoincidentConstraint ( NXOpen.Sketch.ConstraintGeometry  geom1,
NXOpen.Sketch.ConstraintGeometry  geom2 
)

Creates a coincident constraint

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
geom1Must be a vertex
geom2Must be a vertex
Returns
The coincident constraint
unsafe NXOpen.SketchGeometricConstraint NXOpen.Sketch.CreateCollinearConstraint ( NXOpen.Sketch.ConstraintGeometry  conGeom1,
NXOpen.Sketch.ConstraintGeometry  conGeom2 
)

Creates a collinear constraint.

One of the input constraint geometries must be a line.

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
conGeom1Must be a line, linear edge, datum axis, or datum plane
conGeom2Must be a line, linear edge, datum axis, or datum plane
Returns
The collinear constraint
unsafe NXOpen.SketchGeometricConstraint NXOpen.Sketch.CreateConcentricConstraint ( NXOpen.Sketch.ConstraintGeometry  conGeom1,
NXOpen.Sketch.ConstraintGeometry  conGeom2 
)

Creates a concentric constraint.

One of the input constraint geometries must be a curve.

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
conGeom1Must be an arc or ellipse or edge shaped as an arc or ellipse
conGeom2Must be an arc or ellipse or edge shaped as an arc or ellipse
Returns
The concentric constraint
unsafe NXOpen.SketchGeometricConstraint NXOpen.Sketch.CreateConstantAngleConstraint ( NXOpen.Sketch.ConstraintGeometry  conGeom)

Creates a constant angle constraint

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
conGeomMust be a line
Returns
The constant angle constraint
unsafe NXOpen.SketchGeometricConstraint NXOpen.Sketch.CreateConstantLengthConstraint ( NXOpen.Sketch.ConstraintGeometry  conGeom)

Creates a constant length constraint

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
conGeomMust be a line
Returns
The constant length constraint
unsafe NXOpen.SketchDimensionalConstraint NXOpen.Sketch.CreateDiameterDimension ( NXOpen.Sketch.DimensionGeometry  dimObject1,
NXOpen.Point3d  dimOrigin,
NXOpen.Expression  expression 
)

Creates a diameter dimension constraint

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
dimObject1Should be an arc
dimOriginThe location where the dimension should be placed
expressionDefining expression for the dimension. Can be a null reference (Nothing in Visual Basic)
Returns
The diametral dimension constraint
unsafe NXOpen.SketchDimensionalConstraint NXOpen.Sketch.CreateDiameterDimension ( NXOpen.Sketch.DimensionGeometry  dimObject1,
NXOpen.Point3d  dimOrigin,
NXOpen.Expression  expression,
NXOpen.Sketch.DimensionOption  refDim 
)

Creates a diameter dimension constraint.

Accepts a flag to create the dim as driving or reference

Created in NX4.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
dimObject1Should be an arc
dimOriginThe location where the dimension should be placed
expressionDefining expression for the dimension. Can be a null reference (Nothing in Visual Basic)
refDimoption for creating driving or reference dimension
Returns
The diametral dimension constraint
unsafe NXOpen.SketchDimensionalConstraint NXOpen.Sketch.CreateDimension ( NXOpen.Sketch.ConstraintType  dimType,
NXOpen.Sketch.DimensionGeometry  dimObject1,
NXOpen.Sketch.DimensionGeometry  dimObject2,
NXOpen.Point3d  dimOrigin,
NXOpen.Expression  expression 
)

Creates a dimension between two geometric objects.

Do not use for radial, diameter, or perimeter dimensions. To create a radial or diameter constraint, use NXOpen.Sketch.CreateRadialDimension or NXOpen.Sketch.CreateDiameterDimension . To create a perimeter dimension, use NXOpen.Sketch.CreatePerimeterDimension

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
dimTypeMust be one of the dimension types and should not be a radial, diametral, or perimeter dimension
dimObject1First input geometry
dimObject2Second input geometry
dimOriginThe location where the dimension should be placed
expressionDefining expression for the dimension. Can be a null reference (Nothing in Visual Basic)
Returns
The dimensional constraint
unsafe NXOpen.SketchDimensionalConstraint NXOpen.Sketch.CreateDimension ( NXOpen.Sketch.ConstraintType  dimType,
NXOpen.Sketch.DimensionGeometry  dimObject1,
NXOpen.Sketch.DimensionGeometry  dimObject2,
NXOpen.Point3d  dimOrigin,
NXOpen.Expression  expression,
NXOpen.Sketch.DimensionOption  refDim 
)

Creates a dimension between two geometric objects.

Do not use for radial, diameter, or perimeter dimensions. To create a radial or diameter constraint, use NXOpen.Sketch.CreateRadialDimension or NXOpen.Sketch.CreateDiameterDimension . To create a perimeter dimension, use NXOpen.Sketch.CreatePerimeterDimension . This function takes in an argument to create the dimension as driving or reference.

Created in NX4.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
dimTypeMust be one of the dimension types and should not be a radial, diametral, or perimeter dimension
dimObject1First input geometry
dimObject2Second input geometry
dimOriginThe location where the dimension should be placed
expressionDefining expression for the dimension. Can be a null reference (Nothing in Visual Basic)
refDimoption for creating driving or reference dimension
Returns
The dimensional constraint
unsafe NXOpen.SketchGeometricConstraint NXOpen.Sketch.CreateEqualLengthConstraint ( NXOpen.Sketch.ConstraintGeometry  conGeom1,
NXOpen.Sketch.ConstraintGeometry  conGeom2 
)

Creates an equal length constraint.

One of the input constraint geometries must be a line.

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
conGeom1Must be a line or linear edge
conGeom2Must be a line or linear edge
Returns
The equal length constraint
unsafe NXOpen.SketchGeometricConstraint NXOpen.Sketch.CreateEqualRadiusConstraint ( NXOpen.Sketch.ConstraintGeometry  conGeom1,
NXOpen.Sketch.ConstraintGeometry  conGeom2 
)

Creates an equal radius constraint.

One of the input constraint geometries must be a curve.

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
conGeom1Must be an arc or edge shaped as an arc
conGeom2Must be an arc or edge shaped as an arc
Returns
The equal radius constraint
unsafe NXOpen.SketchGeometricConstraint NXOpen.Sketch.CreateFixedConstraint ( NXOpen.Sketch.ConstraintGeometry  geom)

Creates a fixed constraint

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
geomCan be any curve, point, or vertex in the sketch
Returns
The fixed constraint
unsafe NXOpen.SketchGeometricConstraint [] NXOpen.Sketch.CreateFullyFixedConstraints ( NXOpen.Sketch.ConstraintGeometry  geom)

Creates enough fixed constraints on the curve and all of its vertices such that the geometry is fully fixed without any redundant fixed constraints.

Created in NX5.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
geomCan be any curve, point, or vertex in the sketch
Returns
The fixed constraints
unsafe NXOpen.SketchGeometricConstraint NXOpen.Sketch.CreateHorizontalConstraint ( NXOpen.Sketch.ConstraintGeometry  geom)

Creates a horizontal constraint

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
geomMust be a line
Returns
The horizontal constraint
unsafe NXOpen.SketchGeometricConstraint NXOpen.Sketch.CreateMidpointConstraint ( NXOpen.Sketch.ConstraintGeometry  conGeom1,
NXOpen.Sketch.ConstraintGeometry  conGeom2 
)

Creates a midpoint constraint.

One of the input constraint geometries must be a vertex and the other must be a curve or edge.

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
conGeom1
conGeom2
Returns
The midpoint constraint
unsafe NXOpen.SketchGeometricConstraint NXOpen.Sketch.CreateNonUniformScaledConstraint ( NXOpen.Sketch.ConstraintGeometry  conGeom)

Creates a non-uniform scale constraint

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
conGeomMust be a spline
Returns
The non-uniform scale constraint

Creates a normal constraint.

A normal constraint can be created between any two curve/edge type except between two linear objects. For linear objects, create a perpendicular constraint

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
conGeom1First input geometry for the constraint
geom1HelpHelp data for first geom
conGeom2Second input geometry for the constraint
geom2HelpHelp data for second geom
Returns
The normal constraint
unsafe NXOpen.SketchGeometricConstraint NXOpen.Sketch.CreateParallelConstraint ( NXOpen.Sketch.ConstraintGeometry  conGeom1,
NXOpen.Sketch.ConstraintGeometry  conGeom2 
)

Creates a parallel constraint.

A parallel constraint can only be created between one of the following pairs: (line, line or linear edge), (line, datum axis or datum plane), (line or linear edge, ellipse), (line, ellipse or elliptical edge), (ellipse, ellipse or elliptical edge).

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
conGeom1First input geometry for the constraint
conGeom2Second input geometry for the constraint
Returns
The parallel constraint
unsafe NXOpen.SketchDimensionalConstraint NXOpen.Sketch.CreatePerimeterDimension ( NXOpen.Curve[]  curves,
NXOpen.Point3d  dimOrigin,
NXOpen.Expression  expression 
)

Creates a perimeter dimension constraint

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
curvesThe curves that form the perimeter
dimOriginNot currently used
expressionDefining expression for the dimension. Can be a null reference (Nothing in Visual Basic)
Returns
The perimeter dimensional constraint
unsafe NXOpen.SketchGeometricConstraint NXOpen.Sketch.CreatePerpendicularConstraint ( NXOpen.Sketch.ConstraintGeometry  conGeom1,
NXOpen.Sketch.ConstraintGeometry  conGeom2 
)

Creates a perpendicular constraint.

A perpendicular constraint can only be created between one of the following pairs: (line, line or linear edge), (line, datum axis or datum plane), (line or linear edge, ellipse), (line, ellipse or elliptical edge), (ellipse, ellipse or elliptical edge).

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
conGeom1First input geometry for the constraint
conGeom2Second input geometry for the constraint
Returns
The perpendicular constraint
unsafe NXOpen.SketchHelpedGeometricConstraint NXOpen.Sketch.CreatePointOnCurveConstraint ( NXOpen.Sketch.ConstraintGeometry  conGeom1,
NXOpen.Sketch.ConstraintGeometry  conGeom2,
NXOpen.Sketch.ConstraintGeometryHelp  help 
)

Creates a point on curve constraint.

One of the input geometries must be a vertex and the other must be a curve, edge, datum axis, or datum plane.

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
conGeom1
conGeom2
help
Returns
The point on curve constraint
unsafe NXOpen.SketchHelpedGeometricConstraint NXOpen.Sketch.CreatePointOnStringConstraint ( NXOpen.Sketch.ConstraintGeometry  conGeom1,
NXOpen.Curve[]  curvesInString,
NXOpen.Sketch.ConstraintGeometryHelp  helpData,
int  curveWhichHelpParamAppliesTo 
)

Creates a point on string constraint.

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
conGeom1Must be a vertex
curvesInStringMust all be part of the same string. (You can create a string of curves through the UI through the Edit -> Project command.)
helpData
curveWhichHelpParamAppliesToIf helpData is a parameter, this parameter indicates which curve in the curvesInString that the help parameter applies to. Otherwise, this parameter is not used
Returns
The point on string constraint
unsafe NXOpen.SketchHelpedGeometricConstraint NXOpen.Sketch.CreatePointOnStringConstraint ( NXOpen.Sketch.ConstraintGeometry  conGeom1,
NXOpen.Curve  curveInString,
NXOpen.Sketch.ConstraintGeometryHelp  helpData 
)

Creates a point on string constraint.

The string is specified using a single curve in the string. The constraint is created on the entire string that curveInString belongs to.

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
conGeom1Must be a vertex
curveInStringA curve in the string that you want to create the constraint on. The constraint is created on the entire string that this curve belongs to. (You can create a string of curves through the UI through the Edit -> Project command.)
helpData
Returns
The point on string constraint
unsafe NXOpen.SketchDimensionalConstraint NXOpen.Sketch.CreateRadialDimension ( NXOpen.Sketch.DimensionGeometry  dimObject1,
NXOpen.Point3d  dimOrigin,
NXOpen.Expression  expression 
)

Creates a radial dimension constraint

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
dimObject1Should be an arc
dimOriginThe location where the dimension should be placed
expressionDefining expression for the dimension. Can be a null reference (Nothing in Visual Basic)
Returns
The radial dimension constraint
unsafe NXOpen.SketchDimensionalConstraint NXOpen.Sketch.CreateRadialDimension ( NXOpen.Sketch.DimensionGeometry  dimObject1,
NXOpen.Point3d  dimOrigin,
NXOpen.Expression  expression,
NXOpen.Sketch.DimensionOption  refDim 
)

Creates a radial dimension constraint.

Accepts a flag to create the dimension as driving or reference

Created in NX4.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
dimObject1Should be an arc
dimOriginThe location where the dimension should be placed
expressionDefining expression for the dimension. Can be a null reference (Nothing in Visual Basic)
refDimoption for creating driving or reference dimension
Returns
The radial dimension constraint
unsafe NXOpen.SketchGeometricConstraint NXOpen.Sketch.CreateSlopeConstraint ( NXOpen.Sketch.ConstraintGeometry  conGeom1,
NXOpen.Sketch.ConstraintGeometry  conGeom2 
)

Creates a slope constraint.

One of the input constraint geometries must a spline defining point. The other must be datum axis, datum plane, or a curve or edge shaped as a line, arc, ellipse, conic, or spline.

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
conGeom1
conGeom2
Returns
The slope constraint

Creates a tangent constraint.

Note: the input constraint geometries cannot both be linear.

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
geom1A curve, edge, or datum axis
geom1Help
geom2A curve, edge, or datum axis
geom2Help
Returns
The tangent constraint
unsafe NXOpen.SketchGeometricConstraint NXOpen.Sketch.CreateUniformScaledConstraint ( NXOpen.Sketch.ConstraintGeometry  conGeom)

Creates a uniform scale constraint

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
conGeomMust be a spline
Returns
The uniform scale constraint
unsafe NXOpen.SketchGeometricConstraint NXOpen.Sketch.CreateVerticalConstraint ( NXOpen.Sketch.ConstraintGeometry  geom)

Creates a vertical constraint

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
geomMust be a line
Returns
The vertical constraint
unsafe void NXOpen.Sketch.Deactivate ( NXOpen.Sketch.ViewReorient  orientView,
NXOpen.Sketch.UpdateLevel  updateLevel 
)

Deactivates the sketch

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
orientViewIndicates whether to orient the view to the model during deactivation
updateLevelIndicates whether just the sketch should be updated or the entire model
unsafe void NXOpen.Sketch.DeleteConstraintsOnGeometries ( NXOpen.NXObject[]  objects)

Deletes all geometric constraints associated with the object and all of its vertices.

Converts all the driving dimensions associated with the object and its vertices to reference dimensions.

Created in NX4.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
objectsObjects whose constraints needs to be deleted
unsafe void NXOpen.Sketch.DeleteConstraintsOnGeometries ( NXOpen.Sketch.ConstraintGeometry[]  objects)

Deletes all geometric constraints associated with the object and all of its vertices.

Converts all the driving dimensions associated with the object and its vertices to reference dimensions. The user can pass in a vertex to do the same on just the supplied vertex.

Created in NX8.5.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
objectsObjects whose constraints needs to be deleted
unsafe void NXOpen.Sketch.DeleteConstraintsOnGeometries ( NXOpen.Sketch.ConstraintClass  conClass,
NXOpen.Sketch.ConstraintGeometry[]  objects 
)

Deletes constraints associated with the input sketch geometry and vertices according to the constraint class, e.

g.,

Created in NX11.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
conClassUse NXOpen.Sketch.ConstraintClass.Any if you do not want to filter by constraint class
objectsObjects whose constraints needs to be deleted
unsafe NXOpen.ErrorList NXOpen.Sketch.DeleteObjects ( NXOpen.NXObject[]  objects)

Deletes objects from the sketch

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
objectsObjects to be deleted
Returns
List of errors encountered during the delete
unsafe void NXOpen.Sketch.EditSplineDefiningPoints ( NXOpen.Spline  spline,
double[]  points 
)

Changes the locations of the defining points of a spline.

The length of point array should be enough to cover existing defining points. You cannot add/remove points nor change knot sequence via this call.

Created in NX10.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
spline
pointspoint locations. Size is three times the number of points.
unsafe void NXOpen.Sketch.EditSplinePoles ( NXOpen.Spline  spline,
double[]  poles 
)

Changes the locations of the control poles of a spline.

The length of poles array should be enough to cover existing poles. You cannot add/remove poles nor change knot sequence via this call. The order of data in poles array is x, y, z, weight. You can edit any or all of these four values via this function.

Created in NX10.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
spline
polespole locations. Size is four times the number of poles.
unsafe NXOpen.Arc [] NXOpen.Sketch.Fillet ( NXOpen.Curve  curve1,
NXOpen.Curve  curve2,
NXOpen.Point3d  helpPoint1,
NXOpen.Point3d  helpPoint2,
double  radius,
NXOpen.Sketch.TrimInputOption  doTrim,
NXOpen.Sketch.CreateDimensionOption  createRadiusDim,
NXOpen.Sketch.AlternateSolutionOption  alternateSolution,
out NXOpen.SketchConstraint[]  constraints 
)

Fillets curves and creates appropriate constraints.

If the input curves have mirror constraints, the fillet is also performed on the mirror curves.

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
curve1First curve for the fillet
curve2Second curve for the fillet
helpPoint1Should be a point on the first curve. Indicates where the fillet should be created
helpPoint2Should be a point on the second curve. Indicates where the fillet should be created
radiusRadius of the fillet
doTrimIndicates whether the input curves should get trimmed by the fillet
createRadiusDimIndicates whether a radius dimension should be created
alternateSolutionIndicates whether the alternate solution should be used instead of the regular solution. The alternate solution for an arc is the portion of the full circle that is left out of the regular solution.
Returns
The fillet arcs that are created. If the input curves do not have any mirror constraints, the number of fillet arcs will always be one. If the input curves have mirror constraints, fillets will be created on the mirrored curves, and all the fillet arcs that were created are returned
Parameters
constraintsThe constraints that were created by the fillet. If the input curves get trimmed, coincident and tangent constraints are created. If the input curves do not get trimmed, point on curve and tangent constraints are created.
unsafe NXOpen.Arc [] NXOpen.Sketch.Fillet ( NXOpen.Curve  curve1,
NXOpen.Curve  curve2,
NXOpen.Point3d  helpPoint1,
NXOpen.Point3d  helpPoint2,
NXOpen.Point3d  pointOnArc,
double  radius,
NXOpen.Sketch.TrimInputOption  doTrim,
NXOpen.Sketch.CreateDimensionOption  createRadiusDim,
NXOpen.Sketch.AlternateSolutionOption  alternateSolution,
out NXOpen.SketchConstraint[]  constraints 
)

Fillets curves and creates appropriate constraints.

If the input curves have mirror constraints, the fillet is also performed on the mirror curves.

Created in NX7.5.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
curve1First curve for the fillet
curve2Second curve for the fillet
helpPoint1Should be a point on the first curve. Indicates where the fillet should be created
helpPoint2Should be a point on the second curve. Indicates where the fillet should be created
pointOnArcPoint on fillet arc
radiusRadius of the fillet
doTrimIndicates whether the input curves should get trimmed by the fillet
createRadiusDimIndicates whether a radius dimension should be created
alternateSolutionIndicates whether the alternate solution should be used instead of the regular solution. The alternate solution for an arc is the portion of the full circle that is left out of the regular solution.
Returns
The fillet arcs that are created. If the input curves do not have any mirror constraints, the number of fillet arcs will always be one. If the input curves have mirror constraints, fillets will be created on the mirrored curves, and all the fillet arcs that were created are returned
Parameters
constraintsThe constraints that were created by the fillet. If the input curves get trimmed, coincident and tangent constraints are created. If the input curves do not get trimmed, point on curve and tangent constraints are created.
unsafe NXOpen.Arc [] NXOpen.Sketch.Fillet ( NXOpen.Curve  curve1,
NXOpen.Curve  curve2,
NXOpen.Curve  curve3,
NXOpen.Point3d  helpPoint1,
NXOpen.Point3d  helpPoint2,
NXOpen.Point3d  helpPoint3,
double  radius,
NXOpen.Sketch.TrimInputOption  doTrim,
NXOpen.Sketch.DeleteThirdCurveOption  doDelete,
NXOpen.Sketch.CreateDimensionOption  createRadiusDim,
NXOpen.Sketch.AlternateSolutionOption  alternateSolution,
out NXOpen.SketchConstraint[]  constraints 
)

Fillets curves and creates appropriate constraints.

If the input curves have mirror constraints, the fillet is also performed on the mirror curves.

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
curve1First curve for the fillet
curve2Second curve for the fillet
curve3Third curve for the fillet
helpPoint1Should be a point on the first curve. Indicates where the fillet should be created
helpPoint2Should be a point on the second curve. Indicates where the fillet should be created
helpPoint3Should be a point on the third curve. Indicates where the fillet should be created
radiusRadius of the fillet
doTrimIndicates whether the input curves should get trimmed by the fillet
doDeleteIndicates whether the third curve should be deleted
createRadiusDimIndicates whether a radius dimension should be created
alternateSolutionIndicates whether the alternate solution should be used instead of the regular solution. The alternate solution for an arc is the portion of the full circle that is left out of the regular solution.
Returns
The fillet arcs that are created. If the input curves do not have any mirror constraints, the number of fillet arcs will always be one. If the input curves have mirror constraints, fillets will be created on the mirrored curves, and all the fillet arcs that were created are returned
Parameters
constraintsThe constraints that were created by the fillet. If the input curves get trimmed, coincident and tangent constraints are created. If the input curves do not get trimmed, point on curve and tangent constraints are created.
unsafe NXOpen.Arc [] NXOpen.Sketch.Fillet ( NXOpen.Curve  curve1,
NXOpen.Curve  curve2,
NXOpen.Curve  curve3,
NXOpen.Point3d  helpPoint1,
NXOpen.Point3d  helpPoint2,
NXOpen.Point3d  helpPoint3,
NXOpen.Point3d  pointOnArc,
double  radius,
NXOpen.Sketch.TrimInputOption  doTrim,
NXOpen.Sketch.DeleteThirdCurveOption  doDelete,
NXOpen.Sketch.CreateDimensionOption  createRadiusDim,
NXOpen.Sketch.AlternateSolutionOption  alternateSolution,
out NXOpen.SketchConstraint[]  constraints 
)

Fillets curves and creates appropriate constraints.

If the input curves have mirror constraints, the fillet is also performed on the mirror curves.

Created in NX7.5.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
curve1First curve for the fillet
curve2Second curve for the fillet
curve3Third curve for the fillet
helpPoint1Should be a point on the first curve. Indicates where the fillet should be created
helpPoint2Should be a point on the second curve. Indicates where the fillet should be created
helpPoint3Should be a point on the third curve. Indicates where the fillet should be created
pointOnArcPoint on fillet arc
radiusRadius of the fillet
doTrimIndicates whether the input curves should get trimmed by the fillet
doDeleteIndicates whether the third curve should be deleted
createRadiusDimIndicates whether a radius dimension should be created
alternateSolutionIndicates whether the alternate solution should be used instead of the regular solution. The alternate solution for an arc is the portion of the full circle that is left out of the regular solution.
Returns
The fillet arcs that are created. If the input curves do not have any mirror constraints, the number of fillet arcs will always be one. If the input curves have mirror constraints, fillets will be created on the mirrored curves, and all the fillet arcs that were created are returned
Parameters
constraintsThe constraints that were created by the fillet. If the input curves get trimmed, coincident and tangent constraints are created. If the input curves do not get trimmed, point on curve and tangent constraints are created.
unsafe void NXOpen.Sketch.FlipNormal ( )

Flips the outward normal vector of the sketch

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

unsafe void NXOpen.Sketch.FlipReferenceDirection ( )

Flips the reference direction of the sketch

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

unsafe NXOpen.SketchConstraint [] NXOpen.Sketch.GetAllConstraintsOfType ( NXOpen.Sketch.ConstraintClass  conClass,
NXOpen.Sketch.ConstraintType  conType 
)

Gets all constraints in the sketch of a particular type

Created in NX3.0.0

License requirements: None.

Parameters
conClassOptional filter. Use NXOpen.Sketch.ConstraintClass.Any if you do not want to filter by constraint class
conTypeOptional filter. Use NXOpen.Sketch.ConstraintType.NoCon if you do not want to filter by constraint type
Returns
All the constraints in the sketch of the specified type
unsafe NXOpen.Expression [] NXOpen.Sketch.GetAllExpressions ( )

Returns all the expressions in the sketch

Created in NX3.0.0

License requirements: None.

Returns
All the expressions in the sketch
unsafe NXOpen.NXObject [] NXOpen.Sketch.GetAllGeometry ( )

Returns all the curves and points in the sketch

Created in NX3.0.0

License requirements: None.

Returns
All the curves and points in the sketch
unsafe NXOpen.SketchConstraint [] NXOpen.Sketch.GetConstraintsForGeometry ( NXOpen.SmartObject  geometry,
NXOpen.Sketch.ConstraintClass  conClass 
)

Gets all the constraints associated with a particular geometric item

Created in NX3.0.0

License requirements: None.

Parameters
geometryMust be a curve or point
conClassOptional filter. Use NXOpen.Sketch.ConstraintClass.Any if you do not want to filter by constraint class
Returns
All the constraints associated with the geometry that is input
unsafe NXOpen.Vector3d NXOpen.Sketch.GetReferenceDirection ( out NXOpen.IReferenceAxis  referenceAxis,
out NXOpen.AxisOrientation  referenceAxisOrientation,
out NXOpen.Sense  referenceAxisSense 
)

Gets the reference direction of the sketch

Created in NX3.0.0

License requirements: None.

Returns
Parameters
referenceAxisAn edge, datum axis, datum plane, or face that the sketch uses as a reference. May be a null reference (Nothing in Visual Basic).
referenceAxisOrientationIndicates whether the reference axis is horizontal or vertical
referenceAxisSenseIf reference axis is an edge or datum axis, this parameter indicates whether the reference axis is in the same direction as the edge or datum axis or in the opposite direction. If reference axis is not an edge or datum axis, this parameter is not used.
unsafe NXOpen.Sketch.Status NXOpen.Sketch.GetStatus ( out int  dofNeeded)

Gets the status of the sketch and the number of degrees of freedom that remain in the sketch.

The status of the sketch indicates whether the sketch is fully constrained or under, over, or inconsistently constrained.

Created in NX3.0.0

License requirements: None.

Returns
The sketch's status, which indicates how well constrained the sketch is
Parameters
dofNeededThe number of degrees of freedom left in the sketch
unsafe void NXOpen.Sketch.HideDimensions ( NXOpen.DisplayableObject[]  inputObjects)

Blanks dimensions in the active sketch associated with the input sketch geometry.

Created in NX4.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
inputObjectsGeometry and groups in active sketch
unsafe void NXOpen.Sketch.HideDimensions ( )

Blanks all the dimensions of input sketch

Created in NX6.0.1

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

unsafe void NXOpen.Sketch.HideDimensions ( NXOpen.Sketch.ConstraintGeometry[]  objects)

Blanks dimensions in the active sketch associated with the input sketch geometry.

This function can accept vertices

Created in NX8.5.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
objectsGeometry and vertices in active sketch
unsafe void NXOpen.Sketch.LocalUpdate ( )

Update the sketch and not the sketch children.

If a different sketch is active the SKETCH_NOT_INITIALIZED error will return. The function works even if the sketch is not active.

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

unsafe void NXOpen.Sketch.MakeDatumsExternal ( )

Makes the internal sketch placement face and directional reference datums external.

Created in NX5.0.0

Deprecated in NX11.0.0. Please use NXOpen.Sketch.MakeDatumsExternal2 instead.

License requirements: solid_modeling ("SOLIDS MODELING") OR geometric_tol ("GDT")

unsafe void NXOpen.Sketch.MakeDatumsExternal2 ( )

Makes the internal sketch placement face and directional reference datums external.

It should be called only when the internal datum is not a datum CSYS or is not a PlaneAxisPoint type of datum CSYS.

Created in NX11.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR geometric_tol ("GDT")

unsafe void NXOpen.Sketch.MakeDatumsInternal ( )

Makes the sketch placement face and directional reference internal to the sketch if they are both datums referenced only by the sketch.

Created in NX5.0.0

Deprecated in NX11.0.0. None.

License requirements: solid_modeling ("SOLIDS MODELING") OR geometric_tol ("GDT")

unsafe void NXOpen.Sketch.ManageConstraintsAfterEdit ( NXOpen.NXObject[]  sketchGeoms,
bool  preserveComplexConstraints 
)

Deletes or adjusts constraints of the input geometry that are incompatible after geometry edit.

Call this before sketch update

Created in NX11.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
sketchGeoms
preserveComplexConstraintsComplex constraints are Pattern, Mirror and Offset
unsafe void NXOpen.Sketch.Reattach ( NXOpen.ISurface  attachmentPlane,
NXOpen.IReferenceAxis  referenceAxis,
NXOpen.Vector3d  referenceDirection,
NXOpen.AxisOrientation  referenceAxisOrientation,
NXOpen.Sense  referenceAxisSense,
NXOpen.PlaneNormalOrientation  normalOrientation,
NXOpen.Point3d  localCoordinateSystemOrigin 
)

Reattaches a sketch.

For documentation for the parameters for this method, see the documentation for NXOpen.SketchCollection.CreateSketch

Created in NX3.0.0

Deprecated in NX11.0.0. Use NXOpen.SketchInPlaceBuilder instead.

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
attachmentPlane
referenceAxis
referenceDirection
referenceAxisOrientation
referenceAxisSense
normalOrientation
localCoordinateSystemOriginOrigin of the sketch's local coordinate system
unsafe void NXOpen.Sketch.RemoveRedundantVertices ( NXOpen.NXObject[]  geoms)

Remove redundant vertices of the given sketch geometry

Created in NX11.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
geomsArray of geometries
unsafe void NXOpen.Sketch.RunAutoDimension ( )

Run auto dimensioning.

Created in NX7.5.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

unsafe void NXOpen.Sketch.Scale ( double  scaleFactor)

Scale the sketch entities by the given scale factor.

The sketch cannot be scaled if there are recipe curves or external constraints/dimensions or constraints/dimensions that controls the size of one or more geometries in the sketch. The sketch can have at most one non-angular driving dimension and that dimension must have its expression value scaled by the scale factor.

Created in NX11.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
scaleFactorthe scaleFactor must be gerater than zero
unsafe void NXOpen.Sketch.SetReferenceDirection ( NXOpen.IReferenceAxis  referenceAxis,
NXOpen.Vector3d  referenceDirection,
NXOpen.AxisOrientation  referenceAxisOrientation,
NXOpen.Sense  referenceAxisSense 
)

Sets the reference direction of the sketch.

For documentation for the parameters for this method, see the documentation for NXOpen.SketchCollection.CreateSketch .

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
referenceAxis
referenceDirection
referenceAxisOrientation
referenceAxisSense
unsafe void NXOpen.Sketch.ShowDimensions ( NXOpen.DisplayableObject[]  inputObjects)

Unblanks dimensions in the active sketch associated with the input sketch geometry

Created in NX4.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
inputObjectsGeometry and groups in active sketch
unsafe void NXOpen.Sketch.ShowDimensions ( )

Unblanks all the dimensions of input sketch

Created in NX6.0.1

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

unsafe void NXOpen.Sketch.ShowDimensions ( NXOpen.Sketch.ConstraintGeometry[]  objects)

Unblanks dimensions in the active sketch associated with the input sketch geometry.

This function can accept vertices.

Created in NX8.5.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
objectsGeometry and vertices in active sketch
unsafe void NXOpen.Sketch.Update ( )

Updates the sketch

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

unsafe void NXOpen.Sketch.Update ( NXOpen.NXObject[]  geoms)

Updates the given set of geometries in the sketch

Created in NX4.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
geomsGeoms that need to be updated
unsafe void NXOpen.Sketch.UpdateConstraintDisplay ( )

Updates the constraint display without updating the sketch

Created in NX3.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

unsafe void NXOpen.Sketch.UpdateConstraintDisplay ( NXOpen.SmartObject[]  geoms)

Updates the constraint display of given set of geoms without updating the sketch

Created in NX4.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
geomsGeoms for which cons must be re-displayed
unsafe void NXOpen.Sketch.UpdateDimensionDisplay ( )

Updates the dimension display without updating the sketch

Created in NX4.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

unsafe void NXOpen.Sketch.UpdateDimensionDisplay ( NXOpen.SmartObject[]  geoms)

Updates the dimension display of given set of geoms without updating the sketch

Created in NX4.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
geomsGeoms for which cons must be re-displayed
unsafe void NXOpen.Sketch.UpdateDimensionDisplay ( NXOpen.NXObject[]  dims)

Updates the dimension display of given set of dims without updating the sketch

Created in NX4.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING")

Parameters
dimsDims for which cons must be re-displayed
unsafe void NXOpen.Sketch.UpdateGeometryDisplay ( )

Updates the geometry display without updating the sketch

Created in NX4.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

unsafe void NXOpen.Sketch.UpdateGeometryDisplay ( NXOpen.SmartObject[]  geoms)

Updates the geometry display of given set of geoms without updating the sketch

Created in NX4.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

Parameters
geomsGeoms for which cons must be re-displayed

Property Documentation

unsafe NXOpen.ISurface NXOpen.Sketch.AttachPlane
get

Returns the plane that the sketch is attached to

Created in NX3.0.0

License requirements: None.

unsafe NXOpen.Sketch.CreateInferConstraintSetting NXOpen.Sketch.CreateInferConstraintsSetting
getset

Returns or sets the toggle that controls the creation of infer constraints in sketch

Created in NX4.0.0

License requirements to get this property: None.

License requirements to set this property: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

unsafe bool NXOpen.Sketch.DOFDisplay
getset

Returns or sets a flag indicating whether the degree of freedom arrows are currently being displayed

Created in NX3.0.0

License requirements to get this property: None.

License requirements to set this property: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

unsafe NXOpen.Features.Feature NXOpen.Sketch.Feature
get

Returns the feature associated with this sketch

Created in NX3.0.0

License requirements: None.

unsafe bool NXOpen.Sketch.IsActive
get

Returns true if the sketch is active

Created in NX3.0.0

License requirements: None.

unsafe bool NXOpen.Sketch.IsDraftingSketch
get

Returns true if drafting sketch

Created in NX6.0.0

License requirements: None.

unsafe bool NXOpen.Sketch.IsInternal
get

Returns true if the sketch is internal.

Created in NX6.0.0

License requirements: solid_modeling ("SOLIDS MODELING") OR geometric_tol ("GDT")

unsafe NXOpen.NXMatrix NXOpen.Sketch.Orientation
get

Returns the orientation matrix of the local coordinate system of the sketch

Created in NX3.0.0

License requirements: None.

unsafe NXOpen.Point3d NXOpen.Sketch.Origin
get

Returns the location of the origin of the local coordinate system for the sketch

Created in NX3.0.0

License requirements: None.

NXOpen.Preferences.SketchPreferences NXOpen.Sketch.Preferences
get

Contains preferences for the sketch

Created in NX3.0.0

unsafe NXOpen.Sketch.UpdateLevel NXOpen.Sketch.UpdateScope
getset

Returns or sets the current update scope.

Used in Direct Sketch to control update

Created in NX8.0.0

License requirements to get this property: None.

License requirements to set this property: solid_modeling ("SOLIDS MODELING") OR drafting ("DRAFTING") OR geometric_tol ("GDT")

unsafe NXOpen.View NXOpen.Sketch.View
get

Returns the view corresponding to sketch

Created in NX6.0.0

License requirements: None.


The documentation for this class was generated from the following file:
Copyright 2017 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.